/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This file was generated.
 *  with google-apis-code-generator 1.4.1 (build: 2013-08-14 15:32:06 UTC)
 *  on 2013-08-19 at 20:56:37 UTC 
 */

package com.google.api.services.gan;

import com.google.api.client.googleapis.GoogleUtils;
import com.google.api.client.googleapis.services.AbstractGoogleClientRequest;
import com.google.api.client.googleapis.services.GoogleClientRequestInitializer;
import com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient;
import com.google.api.client.http.HttpRequestInitializer;
import com.google.api.client.http.HttpTransport;
import com.google.api.client.json.JsonFactory;
import com.google.api.client.json.JsonObjectParser;
import com.google.api.client.json.JsonString;
import com.google.common.base.Preconditions;

/**
 * Service definition for Gan (v1beta1).
 *
 * <p>
 * Lets you have programmatic access to your Google Affiliate Network data.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/affiliate-network/" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link GanRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * <p>
 * Upgrade warning: this class now extends {@link AbstractGoogleJsonClient}, whereas in prior
 * version 1.8 it extended {@link com.google.api.client.googleapis.services.GoogleClient}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Gan extends AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    Preconditions.checkState(GoogleUtils.VERSION.equals("1.13.2-beta"),
        "You are currently running with version %s of google-api-client. " +
        "You need version 1.13.2-beta of google-api-client to run version " +
        "1.13.2-beta of the Google Affiliate Network API library.", GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "gan/v1beta1/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   * @deprecated (scheduled to be removed in 1.13)
   */
  @Deprecated
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport
   * @param jsonFactory JSON factory
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Gan(HttpTransport transport, JsonFactory jsonFactory,
      HttpRequestInitializer httpRequestInitializer) {
    super(transport,
        jsonFactory,
        DEFAULT_ROOT_URL,
        DEFAULT_SERVICE_PATH,
        httpRequestInitializer,
        false);
  }

  /**
   * @param transport HTTP transport
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @param rootUrl root URL of the service
   * @param servicePath service path
   * @param jsonObjectParser JSON object parser
   * @param googleClientRequestInitializer Google request initializer or {@code null} for none
   * @param applicationName application name to be sent in the User-Agent header of requests or
   *        {@code null} for none
   * @param suppressPatternChecks whether discovery pattern checks should be suppressed on required
   *        parameters
   */
  Gan(HttpTransport transport,
      HttpRequestInitializer httpRequestInitializer,
      String rootUrl,
      String servicePath,
      JsonObjectParser jsonObjectParser,
      GoogleClientRequestInitializer googleClientRequestInitializer,
      String applicationName,
      boolean suppressPatternChecks) {
    super(transport,
        httpRequestInitializer,
        rootUrl,
        servicePath,
        jsonObjectParser,
        googleClientRequestInitializer,
        applicationName,
        suppressPatternChecks);
  }

  @Override
  protected void initialize(AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Advertisers collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Gan gan = new Gan(...);}
   *   {@code Gan.Advertisers.List request = gan.advertisers().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Advertisers advertisers() {
    return new Advertisers();
  }

  /**
   * The "advertisers" collection of methods.
   */
  public class Advertisers {

    /**
     * Retrieves data about a single advertiser if that the requesting advertiser/publisher has access
     * to it. Only publishers can lookup advertisers. Advertisers can request information about
     * themselves by omitting the advertiserId query parameter.
     *
     * Create a request for the method "advertisers.get".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @return the request
     */
    public Get get(String role, String roleId) throws java.io.IOException {
      Get result = new Get(role, roleId);
      initialize(result);
      return result;
    }

    public class Get extends GanRequest<com.google.api.services.gan.model.Advertiser> {

      private static final String REST_PATH = "{role}/{roleId}/advertiser";

      /**
       * Retrieves data about a single advertiser if that the requesting advertiser/publisher has access
       * to it. Only publishers can lookup advertisers. Advertisers can request information about
       * themselves by omitting the advertiserId query parameter.
       *
       * Create a request for the method "advertisers.get".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @since 1.13
       */
      protected Get(String role, String roleId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Advertiser.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public Get setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public Get setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /** The ID of the advertiser to look up. Optional. */
      @com.google.api.client.util.Key
      private String advertiserId;

      /** The ID of the advertiser to look up. Optional.
       */
      public String getAdvertiserId() {
        return advertiserId;
      }

      /** The ID of the advertiser to look up. Optional. */
      public Get setAdvertiserId(String advertiserId) {
        this.advertiserId = advertiserId;
        return this;
      }

    }
    /**
     * Retrieves data about all advertisers that the requesting advertiser/publisher has access to.
     *
     * Create a request for the method "advertisers.list".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @return the request
     */
    public List list(String role, String roleId) throws java.io.IOException {
      List result = new List(role, roleId);
      initialize(result);
      return result;
    }

    public class List extends GanRequest<com.google.api.services.gan.model.Advertisers> {

      private static final String REST_PATH = "{role}/{roleId}/advertisers";

      /**
       * Retrieves data about all advertisers that the requesting advertiser/publisher has access to.
       *
       * Create a request for the method "advertisers.list".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @since 1.13
       */
      protected List(String role, String roleId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Advertisers.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public List setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public List setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /**
     * Filters out all advertisers for which do not have the given relationship status with the
     * requesting publisher.
     */
      @com.google.api.client.util.Key
      private String relationshipStatus;

      /** Filters out all advertisers for which do not have the given relationship status with the requesting
     publisher.
       */
      public String getRelationshipStatus() {
        return relationshipStatus;
      }

      /**
     * Filters out all advertisers for which do not have the given relationship status with the
     * requesting publisher.
     */
      public List setRelationshipStatus(String relationshipStatus) {
        this.relationshipStatus = relationshipStatus;
        return this;
      }

      /**
     * Filters out all advertisers that have a seven day EPC average lower than the given value
     * (inclusive). Min value: 0.0. Optional.
     */
      @com.google.api.client.util.Key
      private Double minSevenDayEpc;

      /** Filters out all advertisers that have a seven day EPC average lower than the given value
     (inclusive). Min value: 0.0. Optional.
       */
      public Double getMinSevenDayEpc() {
        return minSevenDayEpc;
      }

      /**
     * Filters out all advertisers that have a seven day EPC average lower than the given value
     * (inclusive). Min value: 0.0. Optional.
     */
      public List setMinSevenDayEpc(Double minSevenDayEpc) {
        this.minSevenDayEpc = minSevenDayEpc;
        return this;
      }

      /**
     * Caret(^) delimted list of advertiser categories. Valid categories are defined here:
     * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107581. Filters
     * out all advertisers not in one of the given advertiser categories. Optional.
     */
      @com.google.api.client.util.Key
      private String advertiserCategory;

      /** Caret(^) delimted list of advertiser categories. Valid categories are defined here:
     http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107581. Filters out
     all advertisers not in one of the given advertiser categories. Optional.
       */
      public String getAdvertiserCategory() {
        return advertiserCategory;
      }

      /**
     * Caret(^) delimted list of advertiser categories. Valid categories are defined here:
     * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107581. Filters
     * out all advertisers not in one of the given advertiser categories. Optional.
     */
      public List setAdvertiserCategory(String advertiserCategory) {
        this.advertiserCategory = advertiserCategory;
        return this;
      }

      /**
     * Filters out all advertisers that have a ninety day EPC average lower than the given value
     * (inclusive). Min value: 0.0. Optional.
     */
      @com.google.api.client.util.Key
      private Double minNinetyDayEpc;

      /** Filters out all advertisers that have a ninety day EPC average lower than the given value
     (inclusive). Min value: 0.0. Optional.
       */
      public Double getMinNinetyDayEpc() {
        return minNinetyDayEpc;
      }

      /**
     * Filters out all advertisers that have a ninety day EPC average lower than the given value
     * (inclusive). Min value: 0.0. Optional.
     */
      public List setMinNinetyDayEpc(Double minNinetyDayEpc) {
        this.minNinetyDayEpc = minNinetyDayEpc;
        return this;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** The value of 'nextPageToken' from the previous page. Optional.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** Max number of items to return in this page. Optional. Defaults to 20. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Max number of items to return in this page. Optional. Defaults to 20.

     [minimum: 0] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Max number of items to return in this page. Optional. Defaults to 20. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /**
     * A value between 1 and 4, where 1 represents the quartile of advertisers with the lowest ranks
     * and 4 represents the quartile of advertisers with the highest ranks. Filters out all
     * advertisers with a lower rank than the given quartile. For example if a 2 was given only
     * advertisers with a payout rank of 25 or higher would be included. Optional.
     */
      @com.google.api.client.util.Key
      private Integer minPayoutRank;

      /** A value between 1 and 4, where 1 represents the quartile of advertisers with the lowest ranks and 4
     represents the quartile of advertisers with the highest ranks. Filters out all advertisers with a
     lower rank than the given quartile. For example if a 2 was given only advertisers with a payout
     rank of 25 or higher would be included. Optional.

     [minimum: 1] [maximum: 4]
       */
      public Integer getMinPayoutRank() {
        return minPayoutRank;
      }

      /**
     * A value between 1 and 4, where 1 represents the quartile of advertisers with the lowest ranks
     * and 4 represents the quartile of advertisers with the highest ranks. Filters out all
     * advertisers with a lower rank than the given quartile. For example if a 2 was given only
     * advertisers with a payout rank of 25 or higher would be included. Optional.
     */
      public List setMinPayoutRank(Integer minPayoutRank) {
        this.minPayoutRank = minPayoutRank;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CcOffers collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Gan gan = new Gan(...);}
   *   {@code Gan.CcOffers.List request = gan.ccOffers().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CcOffers ccOffers() {
    return new CcOffers();
  }

  /**
   * The "ccOffers" collection of methods.
   */
  public class CcOffers {

    /**
     * Retrieves credit card offers for the given publisher.
     *
     * Create a request for the method "ccOffers.list".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param publisher The ID of the publisher in question.
     * @return the request
     */
    public List list(String publisher) throws java.io.IOException {
      List result = new List(publisher);
      initialize(result);
      return result;
    }

    public class List extends GanRequest<com.google.api.services.gan.model.CcOffers> {

      private static final String REST_PATH = "publishers/{publisher}/ccOffers";

      /**
       * Retrieves credit card offers for the given publisher.
       *
       * Create a request for the method "ccOffers.list".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param publisher The ID of the publisher in question.
       * @since 1.13
       */
      protected List(String publisher) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.CcOffers.class);
        this.publisher = Preconditions.checkNotNull(publisher, "Required parameter publisher must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the publisher in question. */
      @com.google.api.client.util.Key
      private String publisher;

      /** The ID of the publisher in question.
       */
      public String getPublisher() {
        return publisher;
      }

      /** The ID of the publisher in question. */
      public List setPublisher(String publisher) {
        this.publisher = publisher;
        return this;
      }

      /** The advertiser ID of a card issuer whose offers to include. Optional, may be repeated. */
      @com.google.api.client.util.Key
      private java.util.List<String> advertiser;

      /** The advertiser ID of a card issuer whose offers to include. Optional, may be repeated.
       */
      public java.util.List<String> getAdvertiser() {
        return advertiser;
      }

      /** The advertiser ID of a card issuer whose offers to include. Optional, may be repeated. */
      public List setAdvertiser(java.util.List<String> advertiser) {
        this.advertiser = advertiser;
        return this;
      }

      /** The set of fields to return. */
      @com.google.api.client.util.Key
      private String projection;

      /** The set of fields to return.
       */
      public String getProjection() {
        return projection;
      }

      /** The set of fields to return. */
      public List setProjection(String projection) {
        this.projection = projection;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Events collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Gan gan = new Gan(...);}
   *   {@code Gan.Events.List request = gan.events().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Events events() {
    return new Events();
  }

  /**
   * The "events" collection of methods.
   */
  public class Events {

    /**
     * Retrieves event data for a given advertiser/publisher.
     *
     * Create a request for the method "events.list".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @return the request
     */
    public List list(String role, String roleId) throws java.io.IOException {
      List result = new List(role, roleId);
      initialize(result);
      return result;
    }

    public class List extends GanRequest<com.google.api.services.gan.model.Events> {

      private static final String REST_PATH = "{role}/{roleId}/events";

      /**
       * Retrieves event data for a given advertiser/publisher.
       *
       * Create a request for the method "events.list".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @since 1.13
       */
      protected List(String role, String roleId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Events.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public List setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public List setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /**
     * Caret(^) delimited list of order IDs. Filters out all events that do not reference one of the
     * given order IDs. Optional.
     */
      @com.google.api.client.util.Key
      private String orderId;

      /** Caret(^) delimited list of order IDs. Filters out all events that do not reference one of the given
     order IDs. Optional.
       */
      public String getOrderId() {
        return orderId;
      }

      /**
     * Caret(^) delimited list of order IDs. Filters out all events that do not reference one of the
     * given order IDs. Optional.
     */
      public List setOrderId(String orderId) {
        this.orderId = orderId;
        return this;
      }

      /**
     * Caret(^) delimited list of SKUs. Filters out all events that do not reference one of the
     * given SKU. Optional.
     */
      @com.google.api.client.util.Key
      private String sku;

      /** Caret(^) delimited list of SKUs. Filters out all events that do not reference one of the given SKU.
     Optional.
       */
      public String getSku() {
        return sku;
      }

      /**
     * Caret(^) delimited list of SKUs. Filters out all events that do not reference one of the
     * given SKU. Optional.
     */
      public List setSku(String sku) {
        this.sku = sku;
        return this;
      }

      /**
     * Filters out all events later than given date. Optional. Defaults to 24 hours after eventMin.
     */
      @com.google.api.client.util.Key
      private String eventDateMax;

      /** Filters out all events later than given date. Optional. Defaults to 24 hours after eventMin.
       */
      public String getEventDateMax() {
        return eventDateMax;
      }

      /**
     * Filters out all events later than given date. Optional. Defaults to 24 hours after eventMin.
     */
      public List setEventDateMax(String eventDateMax) {
        this.eventDateMax = eventDateMax;
        return this;
      }

      /**
     * Filters out all events that are not of the given type. Valid values: 'action', 'transaction',
     * 'charge'. Optional.
     */
      @com.google.api.client.util.Key
      private String type;

      /** Filters out all events that are not of the given type. Valid values: 'action', 'transaction',
     'charge'. Optional.
       */
      public String getType() {
        return type;
      }

      /**
     * Filters out all events that are not of the given type. Valid values: 'action', 'transaction',
     * 'charge'. Optional.
     */
      public List setType(String type) {
        this.type = type;
        return this;
      }

      /**
     * Caret(^) delimited list of link IDs. Filters out all events that do not reference one of the
     * given link IDs. Optional.
     */
      @com.google.api.client.util.Key
      private String linkId;

      /** Caret(^) delimited list of link IDs. Filters out all events that do not reference one of the given
     link IDs. Optional.
       */
      public String getLinkId() {
        return linkId;
      }

      /**
     * Caret(^) delimited list of link IDs. Filters out all events that do not reference one of the
     * given link IDs. Optional.
     */
      public List setLinkId(String linkId) {
        this.linkId = linkId;
        return this;
      }

      /**
     * Filters out all events modified earlier than given date. Optional. Defaults to 24 hours
     * before the current modifyDateMax, if modifyDateMax is explicitly set.
     */
      @com.google.api.client.util.Key
      private String modifyDateMin;

      /** Filters out all events modified earlier than given date. Optional. Defaults to 24 hours before the
     current modifyDateMax, if modifyDateMax is explicitly set.
       */
      public String getModifyDateMin() {
        return modifyDateMin;
      }

      /**
     * Filters out all events modified earlier than given date. Optional. Defaults to 24 hours
     * before the current modifyDateMax, if modifyDateMax is explicitly set.
     */
      public List setModifyDateMin(String modifyDateMin) {
        this.modifyDateMin = modifyDateMin;
        return this;
      }

      /**
     * Filters out all events earlier than given date. Optional. Defaults to 24 hours from current
     * date/time.
     */
      @com.google.api.client.util.Key
      private String eventDateMin;

      /** Filters out all events earlier than given date. Optional. Defaults to 24 hours from current
     date/time.
       */
      public String getEventDateMin() {
        return eventDateMin;
      }

      /**
     * Filters out all events earlier than given date. Optional. Defaults to 24 hours from current
     * date/time.
     */
      public List setEventDateMin(String eventDateMin) {
        this.eventDateMin = eventDateMin;
        return this;
      }

      /**
     * Caret(^) delimited list of member IDs. Filters out all events that do not reference one of
     * the given member IDs. Optional.
     */
      @com.google.api.client.util.Key
      private String memberId;

      /** Caret(^) delimited list of member IDs. Filters out all events that do not reference one of the
     given member IDs. Optional.
       */
      public String getMemberId() {
        return memberId;
      }

      /**
     * Caret(^) delimited list of member IDs. Filters out all events that do not reference one of
     * the given member IDs. Optional.
     */
      public List setMemberId(String memberId) {
        this.memberId = memberId;
        return this;
      }

      /** Max number of offers to return in this page. Optional. Defaults to 20. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Max number of offers to return in this page. Optional. Defaults to 20.

     [minimum: 0] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Max number of offers to return in this page. Optional. Defaults to 20. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /**
     * Caret(^) delimited list of advertiser IDs. Filters out all events that do not reference one
     * of the given advertiser IDs. Only used when under publishers role. Optional.
     */
      @com.google.api.client.util.Key
      private String advertiserId;

      /** Caret(^) delimited list of advertiser IDs. Filters out all events that do not reference one of the
     given advertiser IDs. Only used when under publishers role. Optional.
       */
      public String getAdvertiserId() {
        return advertiserId;
      }

      /**
     * Caret(^) delimited list of advertiser IDs. Filters out all events that do not reference one
     * of the given advertiser IDs. Only used when under publishers role. Optional.
     */
      public List setAdvertiserId(String advertiserId) {
        this.advertiserId = advertiserId;
        return this;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** The value of 'nextPageToken' from the previous page. Optional.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
     * Caret(^) delimited list of product categories. Filters out all events that do not reference a
     * product in one of the given product categories. Optional.
     */
      @com.google.api.client.util.Key
      private String productCategory;

      /** Caret(^) delimited list of product categories. Filters out all events that do not reference a
     product in one of the given product categories. Optional.
       */
      public String getProductCategory() {
        return productCategory;
      }

      /**
     * Caret(^) delimited list of product categories. Filters out all events that do not reference a
     * product in one of the given product categories. Optional.
     */
      public List setProductCategory(String productCategory) {
        this.productCategory = productCategory;
        return this;
      }

      /**
     * Filters out all charge events that are not of the given charge type. Valid values: 'other',
     * 'slotting_fee', 'monthly_minimum', 'tier_bonus', 'credit', 'debit'. Optional.
     */
      @com.google.api.client.util.Key
      private String chargeType;

      /** Filters out all charge events that are not of the given charge type. Valid values: 'other',
     'slotting_fee', 'monthly_minimum', 'tier_bonus', 'credit', 'debit'. Optional.
       */
      public String getChargeType() {
        return chargeType;
      }

      /**
     * Filters out all charge events that are not of the given charge type. Valid values: 'other',
     * 'slotting_fee', 'monthly_minimum', 'tier_bonus', 'credit', 'debit'. Optional.
     */
      public List setChargeType(String chargeType) {
        this.chargeType = chargeType;
        return this;
      }

      /**
     * Filters out all events modified later than given date. Optional. Defaults to 24 hours after
     * modifyDateMin, if modifyDateMin is explicitly set.
     */
      @com.google.api.client.util.Key
      private String modifyDateMax;

      /** Filters out all events modified later than given date. Optional. Defaults to 24 hours after
     modifyDateMin, if modifyDateMin is explicitly set.
       */
      public String getModifyDateMax() {
        return modifyDateMax;
      }

      /**
     * Filters out all events modified later than given date. Optional. Defaults to 24 hours after
     * modifyDateMin, if modifyDateMin is explicitly set.
     */
      public List setModifyDateMax(String modifyDateMax) {
        this.modifyDateMax = modifyDateMax;
        return this;
      }

      /**
     * Filters out all events that do not have the given status. Valid values: 'active', 'canceled'.
     * Optional.
     */
      @com.google.api.client.util.Key
      private String status;

      /** Filters out all events that do not have the given status. Valid values: 'active', 'canceled'.
     Optional.
       */
      public String getStatus() {
        return status;
      }

      /**
     * Filters out all events that do not have the given status. Valid values: 'active', 'canceled'.
     * Optional.
     */
      public List setStatus(String status) {
        this.status = status;
        return this;
      }

      /**
     * Caret(^) delimited list of publisher IDs. Filters out all events that do not reference one of
     * the given publishers IDs. Only used when under advertiser role. Optional.
     */
      @com.google.api.client.util.Key
      private String publisherId;

      /** Caret(^) delimited list of publisher IDs. Filters out all events that do not reference one of the
     given publishers IDs. Only used when under advertiser role. Optional.
       */
      public String getPublisherId() {
        return publisherId;
      }

      /**
     * Caret(^) delimited list of publisher IDs. Filters out all events that do not reference one of
     * the given publishers IDs. Only used when under advertiser role. Optional.
     */
      public List setPublisherId(String publisherId) {
        this.publisherId = publisherId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Links collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Gan gan = new Gan(...);}
   *   {@code Gan.Links.List request = gan.links().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Links links() {
    return new Links();
  }

  /**
   * The "links" collection of methods.
   */
  public class Links {

    /**
     * Retrieves data about a single link if the requesting advertiser/publisher has access to it.
     * Advertisers can look up their own links. Publishers can look up visible links or links belonging
     * to advertisers they are in a relationship with.
     *
     * Create a request for the method "links.get".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @param linkId The ID of the link to look up.
     * @return the request
     */
    public Get get(String role, String roleId, Long linkId) throws java.io.IOException {
      Get result = new Get(role, roleId, linkId);
      initialize(result);
      return result;
    }

    public class Get extends GanRequest<com.google.api.services.gan.model.Link> {

      private static final String REST_PATH = "{role}/{roleId}/link/{linkId}";

      /**
       * Retrieves data about a single link if the requesting advertiser/publisher has access to it.
       * Advertisers can look up their own links. Publishers can look up visible links or links
       * belonging to advertisers they are in a relationship with.
       *
       * Create a request for the method "links.get".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @param linkId The ID of the link to look up.
       * @since 1.13
       */
      protected Get(String role, String roleId, Long linkId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Link.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
        this.linkId = Preconditions.checkNotNull(linkId, "Required parameter linkId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public Get setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public Get setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /** The ID of the link to look up. */
      @com.google.api.client.util.Key
      private Long linkId;

      /** The ID of the link to look up.
       */
      public Long getLinkId() {
        return linkId;
      }

      /** The ID of the link to look up. */
      public Get setLinkId(Long linkId) {
        this.linkId = linkId;
        return this;
      }

    }
    /**
     * Inserts a new link.
     *
     * Create a request for the method "links.insert".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @param content the {@link com.google.api.services.gan.model.Link}
     * @return the request
     */
    public Insert insert(String role, String roleId, com.google.api.services.gan.model.Link content) throws java.io.IOException {
      Insert result = new Insert(role, roleId, content);
      initialize(result);
      return result;
    }

    public class Insert extends GanRequest<com.google.api.services.gan.model.Link> {

      private static final String REST_PATH = "{role}/{roleId}/link";

      /**
       * Inserts a new link.
       *
       * Create a request for the method "links.insert".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @param content the {@link com.google.api.services.gan.model.Link}
       * @since 1.13
       */
      protected Insert(String role, String roleId, com.google.api.services.gan.model.Link content) {
        super(Gan.this, "POST", REST_PATH, content, com.google.api.services.gan.model.Link.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public Insert setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public Insert setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

    }
    /**
     * Retrieves all links that match the query parameters.
     *
     * Create a request for the method "links.list".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @return the request
     */
    public List list(String role, String roleId) throws java.io.IOException {
      List result = new List(role, roleId);
      initialize(result);
      return result;
    }

    public class List extends GanRequest<com.google.api.services.gan.model.Links> {

      private static final String REST_PATH = "{role}/{roleId}/links";

      /**
       * Retrieves all links that match the query parameters.
       *
       * Create a request for the method "links.list".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @since 1.13
       */
      protected List(String role, String roleId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Links.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public List setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public List setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /** The type of the link. */
      @com.google.api.client.util.Key
      private String linkType;

      /** The type of the link.
       */
      public String getLinkType() {
        return linkType;
      }

      /** The type of the link. */
      public List setLinkType(String linkType) {
        this.linkType = linkType;
        return this;
      }

      /** The beginning of the start date range. */
      @com.google.api.client.util.Key
      private String startDateMin;

      /** The beginning of the start date range.
       */
      public String getStartDateMin() {
        return startDateMin;
      }

      /** The beginning of the start date range. */
      public List setStartDateMin(String startDateMin) {
        this.startDateMin = startDateMin;
        return this;
      }

      /** The size of the given asset. */
      @com.google.api.client.util.Key
      private java.util.List<String> assetSize;

      /** The size of the given asset.
       */
      public java.util.List<String> getAssetSize() {
        return assetSize;
      }

      /** The size of the given asset. */
      public List setAssetSize(java.util.List<String> assetSize) {
        this.assetSize = assetSize;
        return this;
      }

      /** Field for full text search across title and merchandising text, supports link id search. */
      @com.google.api.client.util.Key
      private String searchText;

      /** Field for full text search across title and merchandising text, supports link id search.
       */
      public String getSearchText() {
        return searchText;
      }

      /** Field for full text search across title and merchandising text, supports link id search. */
      public List setSearchText(String searchText) {
        this.searchText = searchText;
        return this;
      }

      /** The end of the create date range. */
      @com.google.api.client.util.Key
      private String createDateMax;

      /** The end of the create date range.
       */
      public String getCreateDateMax() {
        return createDateMax;
      }

      /** The end of the create date range. */
      public List setCreateDateMax(String createDateMax) {
        this.createDateMax = createDateMax;
        return this;
      }

      /** The beginning of the create date range. */
      @com.google.api.client.util.Key
      private String createDateMin;

      /** The beginning of the create date range.
       */
      public String getCreateDateMin() {
        return createDateMin;
      }

      /** The beginning of the create date range. */
      public List setCreateDateMin(String createDateMin) {
        this.createDateMin = createDateMin;
        return this;
      }

      /** The status of the relationship. */
      @com.google.api.client.util.Key
      private String relationshipStatus;

      /** The status of the relationship.
       */
      public String getRelationshipStatus() {
        return relationshipStatus;
      }

      /** The status of the relationship. */
      public List setRelationshipStatus(String relationshipStatus) {
        this.relationshipStatus = relationshipStatus;
        return this;
      }

      /** Max number of items to return in this page. Optional. Defaults to 20. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Max number of items to return in this page. Optional. Defaults to 20.

     [minimum: 0] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Max number of items to return in this page. Optional. Defaults to 20. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Limits the resulting links to the ones belonging to the listed advertisers. */
      @com.google.api.client.util.Key
      private java.util.List<Long> advertiserId;

      /** Limits the resulting links to the ones belonging to the listed advertisers.
       */
      public java.util.List<Long> getAdvertiserId() {
        return advertiserId;
      }

      /** Limits the resulting links to the ones belonging to the listed advertisers. */
      public List setAdvertiserId(java.util.List<Long> advertiserId) {
        this.advertiserId = advertiserId;
        return this;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** The value of 'nextPageToken' from the previous page. Optional.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The end of the start date range. */
      @com.google.api.client.util.Key
      private String startDateMax;

      /** The end of the start date range.
       */
      public String getStartDateMax() {
        return startDateMax;
      }

      /** The end of the start date range. */
      public List setStartDateMax(String startDateMax) {
        this.startDateMax = startDateMax;
        return this;
      }

      /** The promotion type. */
      @com.google.api.client.util.Key
      private java.util.List<String> promotionType;

      /** The promotion type.
       */
      public java.util.List<String> getPromotionType() {
        return promotionType;
      }

      /** The promotion type. */
      public List setPromotionType(java.util.List<String> promotionType) {
        this.promotionType = promotionType;
        return this;
      }

      /** The role of the author of the link. */
      @com.google.api.client.util.Key
      private String authorship;

      /** The role of the author of the link.
       */
      public String getAuthorship() {
        return authorship;
      }

      /** The role of the author of the link. */
      public List setAuthorship(String authorship) {
        this.authorship = authorship;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Publishers collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Gan gan = new Gan(...);}
   *   {@code Gan.Publishers.List request = gan.publishers().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Publishers publishers() {
    return new Publishers();
  }

  /**
   * The "publishers" collection of methods.
   */
  public class Publishers {

    /**
     * Retrieves data about a single advertiser if that the requesting advertiser/publisher has access
     * to it. Only advertisers can look up publishers. Publishers can request information about
     * themselves by omitting the publisherId query parameter.
     *
     * Create a request for the method "publishers.get".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @return the request
     */
    public Get get(String role, String roleId) throws java.io.IOException {
      Get result = new Get(role, roleId);
      initialize(result);
      return result;
    }

    public class Get extends GanRequest<com.google.api.services.gan.model.Publisher> {

      private static final String REST_PATH = "{role}/{roleId}/publisher";

      /**
       * Retrieves data about a single advertiser if that the requesting advertiser/publisher has access
       * to it. Only advertisers can look up publishers. Publishers can request information about
       * themselves by omitting the publisherId query parameter.
       *
       * Create a request for the method "publishers.get".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @since 1.13
       */
      protected Get(String role, String roleId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Publisher.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public Get setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public Get setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /** The ID of the publisher to look up. Optional. */
      @com.google.api.client.util.Key
      private String publisherId;

      /** The ID of the publisher to look up. Optional.
       */
      public String getPublisherId() {
        return publisherId;
      }

      /** The ID of the publisher to look up. Optional. */
      public Get setPublisherId(String publisherId) {
        this.publisherId = publisherId;
        return this;
      }

    }
    /**
     * Retrieves data about all publishers that the requesting advertiser/publisher has access to.
     *
     * Create a request for the method "publishers.list".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @return the request
     */
    public List list(String role, String roleId) throws java.io.IOException {
      List result = new List(role, roleId);
      initialize(result);
      return result;
    }

    public class List extends GanRequest<com.google.api.services.gan.model.Publishers> {

      private static final String REST_PATH = "{role}/{roleId}/publishers";

      /**
       * Retrieves data about all publishers that the requesting advertiser/publisher has access to.
       *
       * Create a request for the method "publishers.list".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @since 1.13
       */
      protected List(String role, String roleId) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Publishers.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public List setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public List setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /**
     * Caret(^) delimted list of publisher categories. Valid categories: (unclassified|community_and
     * _content|shopping_and_promotion|loyalty_and_rewards|network|search_specialist|comparison_shop
     * ping|email). Filters out all publishers not in one of the given advertiser categories.
     * Optional.
     */
      @com.google.api.client.util.Key
      private String publisherCategory;

      /** Caret(^) delimted list of publisher categories. Valid categories: (unclassified|community_and_conte
     nt|shopping_and_promotion|loyalty_and_rewards|network|search_specialist|comparison_shopping|email).
     Filters out all publishers not in one of the given advertiser categories. Optional.
       */
      public String getPublisherCategory() {
        return publisherCategory;
      }

      /**
     * Caret(^) delimted list of publisher categories. Valid categories: (unclassified|community_and
     * _content|shopping_and_promotion|loyalty_and_rewards|network|search_specialist|comparison_shop
     * ping|email). Filters out all publishers not in one of the given advertiser categories.
     * Optional.
     */
      public List setPublisherCategory(String publisherCategory) {
        this.publisherCategory = publisherCategory;
        return this;
      }

      /**
     * Filters out all publishers for which do not have the given relationship status with the
     * requesting publisher.
     */
      @com.google.api.client.util.Key
      private String relationshipStatus;

      /** Filters out all publishers for which do not have the given relationship status with the requesting
     publisher.
       */
      public String getRelationshipStatus() {
        return relationshipStatus;
      }

      /**
     * Filters out all publishers for which do not have the given relationship status with the
     * requesting publisher.
     */
      public List setRelationshipStatus(String relationshipStatus) {
        this.relationshipStatus = relationshipStatus;
        return this;
      }

      /**
     * Filters out all publishers that have a seven day EPC average lower than the given value
     * (inclusive). Min value 0.0. Optional.
     */
      @com.google.api.client.util.Key
      private Double minSevenDayEpc;

      /** Filters out all publishers that have a seven day EPC average lower than the given value
     (inclusive). Min value 0.0. Optional.
       */
      public Double getMinSevenDayEpc() {
        return minSevenDayEpc;
      }

      /**
     * Filters out all publishers that have a seven day EPC average lower than the given value
     * (inclusive). Min value 0.0. Optional.
     */
      public List setMinSevenDayEpc(Double minSevenDayEpc) {
        this.minSevenDayEpc = minSevenDayEpc;
        return this;
      }

      /**
     * Filters out all publishers that have a ninety day EPC average lower than the given value
     * (inclusive). Min value: 0.0. Optional.
     */
      @com.google.api.client.util.Key
      private Double minNinetyDayEpc;

      /** Filters out all publishers that have a ninety day EPC average lower than the given value
     (inclusive). Min value: 0.0. Optional.
       */
      public Double getMinNinetyDayEpc() {
        return minNinetyDayEpc;
      }

      /**
     * Filters out all publishers that have a ninety day EPC average lower than the given value
     * (inclusive). Min value: 0.0. Optional.
     */
      public List setMinNinetyDayEpc(Double minNinetyDayEpc) {
        this.minNinetyDayEpc = minNinetyDayEpc;
        return this;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** The value of 'nextPageToken' from the previous page. Optional.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** The value of 'nextPageToken' from the previous page. Optional. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** Max number of items to return in this page. Optional. Defaults to 20. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Max number of items to return in this page. Optional. Defaults to 20.

     [minimum: 0] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Max number of items to return in this page. Optional. Defaults to 20. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /**
     * A value between 1 and 4, where 1 represents the quartile of publishers with the lowest ranks
     * and 4 represents the quartile of publishers with the highest ranks. Filters out all
     * publishers with a lower rank than the given quartile. For example if a 2 was given only
     * publishers with a payout rank of 25 or higher would be included. Optional.
     */
      @com.google.api.client.util.Key
      private Integer minPayoutRank;

      /** A value between 1 and 4, where 1 represents the quartile of publishers with the lowest ranks and 4
     represents the quartile of publishers with the highest ranks. Filters out all publishers with a
     lower rank than the given quartile. For example if a 2 was given only publishers with a payout rank
     of 25 or higher would be included. Optional.

     [minimum: 1] [maximum: 4]
       */
      public Integer getMinPayoutRank() {
        return minPayoutRank;
      }

      /**
     * A value between 1 and 4, where 1 represents the quartile of publishers with the lowest ranks
     * and 4 represents the quartile of publishers with the highest ranks. Filters out all
     * publishers with a lower rank than the given quartile. For example if a 2 was given only
     * publishers with a payout rank of 25 or higher would be included. Optional.
     */
      public List setMinPayoutRank(Integer minPayoutRank) {
        this.minPayoutRank = minPayoutRank;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Reports collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Gan gan = new Gan(...);}
   *   {@code Gan.Reports.List request = gan.reports().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Reports reports() {
    return new Reports();
  }

  /**
   * The "reports" collection of methods.
   */
  public class Reports {

    /**
     * Retrieves a report of the specified type.
     *
     * Create a request for the method "reports.get".
     *
     * This request holds the parameters needed by the the gan server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
     * @param roleId The ID of the requesting advertiser or publisher.
     * @param reportType The type of report being requested. Valid values: 'order_delta'. Required.
     * @return the request
     */
    public Get get(String role, String roleId, String reportType) throws java.io.IOException {
      Get result = new Get(role, roleId, reportType);
      initialize(result);
      return result;
    }

    public class Get extends GanRequest<com.google.api.services.gan.model.Report> {

      private static final String REST_PATH = "{role}/{roleId}/report/{reportType}";

      /**
       * Retrieves a report of the specified type.
       *
       * Create a request for the method "reports.get".
       *
       * This request holds the parameters needed by the the gan server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param role The role of the requester. Valid values: 'advertisers' or 'publishers'.
       * @param roleId The ID of the requesting advertiser or publisher.
       * @param reportType The type of report being requested. Valid values: 'order_delta'. Required.
       * @since 1.13
       */
      protected Get(String role, String roleId, String reportType) {
        super(Gan.this, "GET", REST_PATH, null, com.google.api.services.gan.model.Report.class);
        this.role = Preconditions.checkNotNull(role, "Required parameter role must be specified.");
        this.roleId = Preconditions.checkNotNull(roleId, "Required parameter roleId must be specified.");
        this.reportType = Preconditions.checkNotNull(reportType, "Required parameter reportType must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      @com.google.api.client.util.Key
      private String role;

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'.
       */
      public String getRole() {
        return role;
      }

      /** The role of the requester. Valid values: 'advertisers' or 'publishers'. */
      public Get setRole(String role) {
        this.role = role;
        return this;
      }

      /** The ID of the requesting advertiser or publisher. */
      @com.google.api.client.util.Key
      private String roleId;

      /** The ID of the requesting advertiser or publisher.
       */
      public String getRoleId() {
        return roleId;
      }

      /** The ID of the requesting advertiser or publisher. */
      public Get setRoleId(String roleId) {
        this.roleId = roleId;
        return this;
      }

      /** The type of report being requested. Valid values: 'order_delta'. Required. */
      @com.google.api.client.util.Key
      private String reportType;

      /** The type of report being requested. Valid values: 'order_delta'. Required.
       */
      public String getReportType() {
        return reportType;
      }

      /** The type of report being requested. Valid values: 'order_delta'. Required. */
      public Get setReportType(String reportType) {
        this.reportType = reportType;
        return this;
      }

      /** Filters to capture one of the given order IDs. Optional. */
      @com.google.api.client.util.Key
      private java.util.List<String> orderId;

      /** Filters to capture one of the given order IDs. Optional.
       */
      public java.util.List<String> getOrderId() {
        return orderId;
      }

      /** Filters to capture one of the given order IDs. Optional. */
      public Get setOrderId(java.util.List<String> orderId) {
        this.orderId = orderId;
        return this;
      }

      /**
     * The start date (inclusive), in RFC 3339 format, for the report data to be returned. Defaults
     * to one day before endDate, if that is given, or yesterday. Optional.
     */
      @com.google.api.client.util.Key
      private String startDate;

      /** The start date (inclusive), in RFC 3339 format, for the report data to be returned. Defaults to one
     day before endDate, if that is given, or yesterday. Optional.
       */
      public String getStartDate() {
        return startDate;
      }

      /**
     * The start date (inclusive), in RFC 3339 format, for the report data to be returned. Defaults
     * to one day before endDate, if that is given, or yesterday. Optional.
     */
      public Get setStartDate(String startDate) {
        this.startDate = startDate;
        return this;
      }

      /**
     * The end date (exclusive), in RFC 3339 format, for the report data to be returned. Defaults to
     * one day after startDate, if that is given, or today. Optional.
     */
      @com.google.api.client.util.Key
      private String endDate;

      /** The end date (exclusive), in RFC 3339 format, for the report data to be returned. Defaults to one
     day after startDate, if that is given, or today. Optional.
       */
      public String getEndDate() {
        return endDate;
      }

      /**
     * The end date (exclusive), in RFC 3339 format, for the report data to be returned. Defaults to
     * one day after startDate, if that is given, or today. Optional.
     */
      public Get setEndDate(String endDate) {
        this.endDate = endDate;
        return this;
      }

      /**
     * Filters out all events that are not of the given type. Valid values: 'action', 'transaction',
     * or 'charge'. Optional.
     */
      @com.google.api.client.util.Key
      private String eventType;

      /** Filters out all events that are not of the given type. Valid values: 'action', 'transaction', or
     'charge'. Optional.
       */
      public String getEventType() {
        return eventType;
      }

      /**
     * Filters out all events that are not of the given type. Valid values: 'action', 'transaction',
     * or 'charge'. Optional.
     */
      public Get setEventType(String eventType) {
        this.eventType = eventType;
        return this;
      }

      /** Max number of items to return in this page. Optional. Defaults to return all results. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Max number of items to return in this page. Optional. Defaults to return all results.

     [minimum: 0]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Max number of items to return in this page. Optional. Defaults to return all results. */
      public Get setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** The IDs of the advertisers to look up, if applicable. */
      @com.google.api.client.util.Key
      private java.util.List<String> advertiserId;

      /** The IDs of the advertisers to look up, if applicable.
       */
      public java.util.List<String> getAdvertiserId() {
        return advertiserId;
      }

      /** The IDs of the advertisers to look up, if applicable. */
      public Get setAdvertiserId(java.util.List<String> advertiserId) {
        this.advertiserId = advertiserId;
        return this;
      }

      /**
     * Filters out all events that do not have the given status. Valid values: 'active', 'canceled',
     * or 'invalid'. Optional.
     */
      @com.google.api.client.util.Key
      private String status;

      /** Filters out all events that do not have the given status. Valid values: 'active', 'canceled', or
     'invalid'. Optional.
       */
      public String getStatus() {
        return status;
      }

      /**
     * Filters out all events that do not have the given status. Valid values: 'active', 'canceled',
     * or 'invalid'. Optional.
     */
      public Get setStatus(String status) {
        this.status = status;
        return this;
      }

      /** Offset on which to return results when paging. Optional. */
      @com.google.api.client.util.Key
      private Long startIndex;

      /** Offset on which to return results when paging. Optional.

     [minimum: 0]
       */
      public Long getStartIndex() {
        return startIndex;
      }

      /** Offset on which to return results when paging. Optional. */
      public Get setStartIndex(Long startIndex) {
        this.startIndex = startIndex;
        return this;
      }

      /** Filters to capture one of given link IDs. Optional. */
      @com.google.api.client.util.Key
      private java.util.List<String> linkId;

      /** Filters to capture one of given link IDs. Optional.
       */
      public java.util.List<String> getLinkId() {
        return linkId;
      }

      /** Filters to capture one of given link IDs. Optional. */
      public Get setLinkId(java.util.List<String> linkId) {
        this.linkId = linkId;
        return this;
      }

      /** Whether or not to calculate totals rows. Optional. */
      @com.google.api.client.util.Key
      private Boolean calculateTotals;

      /** Whether or not to calculate totals rows. Optional.
       */
      public Boolean getCalculateTotals() {
        return calculateTotals;
      }

      /** Whether or not to calculate totals rows. Optional. */
      public Get setCalculateTotals(Boolean calculateTotals) {
        this.calculateTotals = calculateTotals;
        return this;
      }

      /** The IDs of the publishers to look up, if applicable. */
      @com.google.api.client.util.Key
      private java.util.List<String> publisherId;

      /** The IDs of the publishers to look up, if applicable.
       */
      public java.util.List<String> getPublisherId() {
        return publisherId;
      }

      /** The IDs of the publishers to look up, if applicable. */
      public Get setPublisherId(java.util.List<String> publisherId) {
        this.publisherId = publisherId;
        return this;
      }

    }

  }

  /**
   * Builder for {@link Gan}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport
     * @param jsonFactory JSON factory
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(HttpTransport transport, JsonFactory jsonFactory,
        HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Gan}. */
    @Override
    public Gan build() {
      return new Gan(getTransport(),
          getHttpRequestInitializer(),
          getRootUrl(),
          getServicePath(),
          getObjectParser(),
          getGoogleClientRequestInitializer(),
          getApplicationName(),
          getSuppressPatternChecks());
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    /**
     * Set the {@link GanRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setGanRequestInitializer(
        GanRequestInitializer ganRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(ganRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
